package cn.dankal.share.cache;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.context.annotation.Bean;

/**
 * @author ZGH.MercyModest
 * @version V1.0.0
 * @create 2021-03-26
 */
@EnableCaching
@SpringBootApplication
public class CacheApplication {


    /**
     * register a  {@link Gson}  instanced
     *
     * @return {@link Gson}
     * @see GsonBuilder
     */
    @Bean
    public Gson gson() {
        return new GsonBuilder().create();
    }

    public static void main(String[] args) {
        SpringApplication.run(CacheApplication.class, args);
    }
}
