package cn.dankal.share.cache.controller;

import cn.dankal.share.cache.entity.Provinces;
import cn.dankal.share.cache.service.IProvincesService;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

/**
 * @author ZGH.MercyModest
 * @version V1.0.0
 * @create 2021-03-26
 */
@RestController
@RequestMapping("/test")
public class TestController {

    /**
     * provincesService
     */
    private final IProvincesService provincesService;

    public TestController(IProvincesService provincesService) {
        this.provincesService = provincesService;
    }


    @GetMapping("/{provinceId}")
    public Provinces getProvincesWithSpringCache(@PathVariable("provinceId") String provinceId) {
        return provincesService.detailWithSpringCache(provinceId).orElse(null);
    }

    @PostMapping
    public Integer updateProvinceWithSpringCache(@RequestBody @Validated Provinces provinces) {
        return provincesService.updateProvinces(provinces).orElse(0);
    }
}
