package cn.dankal.share.cache.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;

/**
 * 省份信息表
 *
 * @author ZGH.MercyModest
 * @version V1.0.0
 * @create 2021-03-26
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@TableName("tb_provinces")
public class Provinces implements Serializable {

    private static final long serialVersionUID = -8658488154638835028L;

    /**
     * 主键 id
     */
    private Integer id;

    /**
     * 省份 id
     */
    @NotBlank(message = "provinceId 不能为空")
    private String provinceId;

    /**
     * 省份 名称
     */
    private String provinceName;
}