package cn.dankal.share.provicens;

import cn.dankal.share.ApplicationContextProvider;
import cn.dankal.share.cache.entity.Provinces;
import cn.dankal.share.cache.factory.ThreadExecutorFactory;
import cn.dankal.share.cache.service.IProvincesService;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ThreadPoolExecutor;

/**
 * @author ZGH.MercyModest
 * @version V1.0.0
 * @create 2021-03-26
 */
public class ProvincesServiceTest extends ApplicationContextProvider {

    /**
     * provincesService
     */
    @Autowired
    private IProvincesService provincesService;

    /**
     * 测试 {@link IProvincesService#page(IPage)}
     * <br/>
     * 分页插件有效性校验
     */
    @Test
    @Disabled
    public void testProductServicePage() {
        final int page = 1;
        final int num = 10;
        Page<Provinces> pageObj = new Page<>(page, num);
        provincesService.page(pageObj)
                .getRecords()
                .forEach(System.out::println);
    }

    /**
     * 测试: 高并发对于程序的影响  无缓存
     */
    @Test
    @Disabled
    public void testConcurrentEffectiveWithNoCache() throws InterruptedException {
        final int maximumPoolSize = 5000;
        ThreadPoolExecutor threadPoolExecutor = ThreadExecutorFactory.getThreadPoolExecutor("test-no-cache", maximumPoolSize);
        final String provincesId = "440000";
        for (int i = 0; i < maximumPoolSize; i++) {
            threadPoolExecutor.execute(() -> this.provincesService.detailNoCache(provincesId));
        }
        // 让程序保持运行
        new CountDownLatch(1).await();
    }
    /**
     * 测试: 高并发对于程序的影响  无缓存
     */
    @Test
    @Disabled
    public void testConcurrentEffectiveWithCache() throws InterruptedException {
        final int maximumPoolSize = 10000;
        ThreadPoolExecutor threadPoolExecutor = ThreadExecutorFactory.getThreadPoolExecutor("test-cache", maximumPoolSize);
        final String provincesId = "440000";
        for (int i = 0; i < maximumPoolSize; i++) {
            threadPoolExecutor.execute(() -> this.provincesService.detailWithRedisCache(provincesId));
        }
        // 让程序保持运行
        new CountDownLatch(1).await();
    }
}
